import Joi from "joi";

import { UndefinedOr } from "../../../../../utilities";
import { RuleValidator } from "../../RuleValidator";
import { DomainError, handleDomainError } from "../../errors";
import { Result } from "../Result";
import { IStringValueObjectOptions, StringValueObject } from "../StringValueObject";

export class PostalCode extends StringValueObject {
  protected static validate(value: UndefinedOr<string>, options: IStringValueObjectOptions) {
    const rule = Joi.string()
      .allow(null)
      .allow("")
      .default("")
      .trim()
      .label(options.label ? options.label : "value");

    return RuleValidator.validate<string>(rule, value);
  }

  public static create(value: UndefinedOr<string>, options: IStringValueObjectOptions = {}) {
    const _options = {
      label: "postal_code",
      ...options,
    };

    const validationResult = PostalCode.validate(value, _options);

    if (validationResult.isFailure) {
      return Result.fail(
        handleDomainError(DomainError.INVALID_INPUT_DATA, validationResult.error.message, _options)
      );
    }
    return Result.ok(new PostalCode(validationResult.object));
  }
}

export class PostalCode_ValidationError extends Joi.ValidationError {}
